package partisan.weforge.xyz.pulse

import android.os.Bundle
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import com.google.android.material.button.MaterialButton

class MainFragment : Fragment() {

    private lateinit var prefs: Preferences

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        val view = inflater.inflate(R.layout.fragment_main, container, false)
        prefs = Preferences(requireContext())

        val toggle = view.findViewById<MaterialButton>(R.id.toggle)
        toggle.isCheckable = true
        toggle.isChecked = prefs.isServiceEnabledByUser

        toggle.setOnClickListener {
            // the button toggles itself internally since it's checkable
            val isNowChecked = toggle.isChecked
            prefs.isServiceEnabledByUser = isNowChecked

            // Log.d("ButtonState", """
            //     User toggle: $isNowChecked
            //     Prefs effective state (hasPerms): ${prefs.isEnabled}
            // """.trimIndent())

            toggle.post {
                toggle.jumpDrawablesToCurrentState()
                toggle.invalidate()
            }
        }

        return view
    }
}
